PROCEDURE PrntTags
*-------------------------------------------------------------------------------
*-- Programmer..: David Love (DAVIDLOVE)
*-- Date........: 01/31/1992
*-- Notes.......: This routine is a "quick and not-so-dirty" method of printing
*--               the tag and key expressions for a dbf's production mdx file.
*--               It obviates the need for DISP/LIST STAT TO PRINT (or DISP STAT
*--               followed by SHIFT+PrtScr).
*--               This code is modified from the procedure RedoTags.prg,
*--               previously posted on the BORBBS.
*--             : The proc will print the full key expression, including
*--               FOR/DESCENDING/UNIQUE options, if present.
*-- Written for.: dBASE IV, 1.1
*-- Rev. History: 04/18/1992 for version 1.5
*-- Calls.......: None
*-- Called by...: Any
*-- Usage.......: do PrntTags with "<cDBF>"
*-- Example.....: do PrntTags with "Referral"
*-- Returns.....: None
*-- Parameters..: cDBF = Name of DATABASE file, no extension necessary.
*-------------------------------------------------------------------------------

    PARAMETER cDBF
	
    USE (cDBF)
    
    *-- First, figure out how many tags exist

    PRIVATE nMaxTags
    nMaxTags = TAGCOUNT( cDBF,1 )
    
    *-- only perform routine if an index tag exists
    if nMaxTags > 0
      PRIVATE nTags, mkey, mtag
	
      *-- store the keys and tags to an array
      DECLARE aTags[nMaxTags,5]
	  nTags = 1
      DO WHILE nTags <= nMaxTags
        STORE KEY( (cDBF),nTags) TO aTags[nTags,1]        && grab the key
        STORE TAG( (cDBF),nTags) TO aTags[nTags,2]        && grab the tagname
        STORE FOR( (cDBF),nTags) TO aTags[nTags,3]        && grab the for clause
        STORE DESCENDING( (cDBF),nTags) TO aTags[nTags,4] && .t. if descending
        STORE UNIQUE( (cDBF),nTags) TO aTags[nTags,5]     && .t. if unique
	    nTags = nTags + 1
      ENDDO
	
      *-- print each tag with it's key expression
      PRIVATE cTalk
      cTalk = SET("TALK")
      SET TALK OFF
      SET PRINTER ON
      ?? "DATABASE: "+cDBF AT 0
      ?
      ?? "TAG" at 0
      ?? "KEY EXPRESSION" AT 12
      ?
      nTags = 1
      DO WHILE nTags <= nMaxTags
        ?? aTags[nTags,2] AT 0
        ?? aTags[nTags,1] + ;
          IIF(""#aTags[nTags,3]," FOR "+aTags[nTags,3],"") + ;
          IIF(aTags[nTags,4]," DESCENDING","") + ;
          IIF(aTags[nTags,5]," UNIQUE","") AT 12
        ?
        nTags = nTags + 1
      ENDDO
      ?
      SET PRINTER OFF
      SET TALK &cTalk.

      *-- release the array ...
      RELEASE aTags
	
    ENDIF  && check for tags ...
    USE    && close database
    
RETURN

*-- EoP: PrntTags
